;Program compiled by Great Cow BASIC (0.98.06 2019-06-12 (Windows 32 bit))
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.
;
;Importante: use a opo 'Disable Case Sensitivity" no compilador para no dar
;erros de variveis no declaradas.
;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F675, r=DEC
#include <P12F675.inc>
 __CONFIG _CP_OFF & _MCLRE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
      ERRORLEVEL -302
;********************************************************************************

;Set aside memory locations for variables
AUX	EQU	36
BSER	EQU	42
CENT	EQU	43
DADO1	EQU	44
DELAYTEMP	EQU	32
DELAYTEMP2	EQU	33
DEZ	EQU	45
STRINGPOINTER	EQU	46
SYSBYTETEMPA	EQU	37
SYSBYTETEMPB	EQU	41
SYSBYTETEMPX	EQU	32
SYSSTRINGA	EQU	39
SYSSTRINGA_H	EQU	40
SYSTEMP1	EQU	47
SYSTEMP2	EQU	48
SYSWAITTEMPMS	EQU	34
SYSWAITTEMPMS_H	EQU	35
SYSWAITTEMPUS	EQU	37
SYSWAITTEMPUS_H	EQU	38
TMR_SALVO	EQU	49
UN	EQU	50
VAL1	EQU	51

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	4
	retfie

;********************************************************************************

;Start of program memory page 0
	ORG	5
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS

;Start of the main program
;***************************************************************************
;FREQ_DETECT
;C' PIC 12F675
;DETECTA FREQUNCIAS DENTRO DE UMA FAIXA DE TRABALHO E ACIONA SADA.
;MXIMA FREQUNCIA = 65536 HERTZ
;MNIMA FREQUNCIA = 256 HERTZ
;AUTOR: CLAUDIO LARIOS
;DATA:08'09'2020
;USE COMPILADOR GREAT COW BASIC
;USO DIDTICO
;ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
;****************************************************************************
;abaixo voce deve definir a faixa passante de frequncia que acender o led
;#define FREQ_MAX 132 '33792 khz / 256
;#define FREQ_MIN 125 '32000khz / 256
;no caso acender o led na faixa de 32khz a 33,792 khz
;#define in_freq   GPIO.2  'pino 5 - entrada da frequncia
;Dir     in_freq   in
	banksel	TRISIO
	bsf	TRISIO,2
;#define led       GPIO.5  'pino 2 - led de faixa passante
;Dir     led       out
	bcf	TRISIO,5
;#define tx_out_    GPIO.4  'pino 3 - saida para rs 232 tx
;Dir     tx_out_    out
	bcf	TRISIO,4
;variveis globais
;Dim tmr_salvo as byte: tmr_salvo = 0
	clrf	TMR_SALVO
;Dim cent as byte: cent = 0
	clrf	CENT
;Dim dez as byte: dez = 0
	clrf	DEZ
;Dim un  as byte: un = 0
	clrf	UN
;Dim aux as byte
;defines
;#define USAR_SERIAL  ' Deixe descomentado para poder enviar pela SERIAL
;sub-rotinas
;**********************************************************************
;Converte valor para decimal
;**********************************************************************
;Sub env_byte( bser as byte)
;tx_out = 0
;wait 25 us 'start bit
;for  aux = 1 to 8
;if bser & 1 then
;tx_out = 1
;else
;tx_out = 0
;end if
;bser = FnLSR(bser, 1)'desloca um bit a direita
;wait 11 us
;next
;tx_out = 1
;wait 26 us 'stop bit
;End sub
;***************************************************************************
;ROTINA MAIN
;****************************************************************************
;ANSEL = 0
	clrf	ANSEL
;option_reg = 0b10101000
	movlw	168
	movwf	OPTION_REG
;TRISIO = 0b001111 'ajusta entradas e sadas
	movlw	15
	movwf	TRISIO
;CMCON = 7 'desliga comparadores
	movlw	7
	banksel	CMCON
	movwf	CMCON
;GPIO = 0 'zera tudo
	clrf	GPIO
;set tx_out_ on
	bsf	GPIO,4
;***************************************************************************
;LOOP PRINCIPAL DE REPETIO
;****************************************************************************
;do
SysDoLoop_S1
;o timer 1 foi usado para dar mais preciso na janela de tempo de
;leitura  feita pelo timer 0.
;TRISIO = 0B001111
	movlw	15
	banksel	TRISIO
	movwf	TRISIO
;T1CON = 0  'desliga timer 1
	banksel	T1CON
	clrf	T1CON
;TMR1H = 0xf0  ' para contar 3906 us (65535 - 3906 = 61629 ou 0xf0bd)
	movlw	240
	movwf	TMR1H
;TMR1L = 0xbd
	movlw	189
	movwf	TMR1L
;TMR1IF  =0  'reseta flag de overflow do timer 1
	bcf	PIR1,TMR1IF
;TMR0 = 0
	clrf	TMR0
;T0IF = 0
	bcf	INTCON,T0IF
;TMR0 = 0
	clrf	TMR0
;T1CON = 1
	movlw	1
	movwf	T1CON
;wait while TMR1IF = 0 ' aguarda enquanto acaba a janela de tempo de
SysWaitLoop1
	btfss	PIR1,TMR1IF
	goto	SysWaitLoop1
;leitura do timer 0
;tmr_salvo = TMR0 'salva a leitura do timer 0
	movf	TMR0,W
	movwf	TMR_SALVO
;env_ser(tmr_salvo) 'transmite para serial no pino 3
	movwf	VAL1
	call	ENV_SER
;if tmr_salvo >= FREQ_MIN and tmr_salvo <= FREQ_MAX then
	movf	TMR_SALVO,W
	movwf	SysBYTETempA
	movlw	125
	movwf	SysBYTETempB
	call	SysCompLessThan
	comf	SysByteTempX,F
	movf	SysByteTempX,W
	movwf	SysTemp1
	movf	TMR_SALVO,W
	movwf	SysBYTETempB
	movlw	132
	movwf	SysBYTETempA
	call	SysCompLessThan
	comf	SysByteTempX,F
	movf	SysTemp1,W
	andwf	SysByteTempX,W
	movwf	SysTemp2
	btfss	SysTemp2,0
	goto	ELSE1_1
;set led on  'frequncia na entrada esta na faixa determinada - acende led
	bsf	GPIO,5
;else
	goto	ENDIF1
ELSE1_1
;set led off 'frequncia esta fora da faixa determinada - led apagado
	bcf	GPIO,5
;end if
ENDIF1
;wait 50 ms
	movlw	50
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	call	Delay_MS
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
;-----------------------fim do programa -------------------------------
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

CONVERTE_DEC
;cent = 0x30
	movlw	48
	movwf	CENT
;dez = 0x30
	movlw	48
	movwf	DEZ
;Do while dado1 >= 100
SysDoLoop_S2
	movlw	100
	subwf	DADO1,W
	btfss	STATUS, C
	goto	SysDoLoop_E2
;cent = cent + 1
	incf	CENT,F
;dado1 = dado1 - 100
	movlw	100
	subwf	DADO1,F
;loop
	goto	SysDoLoop_S2
SysDoLoop_E2
;do while dado1 >= 10
SysDoLoop_S3
	movlw	10
	subwf	DADO1,W
	btfss	STATUS, C
	goto	SysDoLoop_E3
;dez = dez + 1
	incf	DEZ,F
;dado1 = dado1 - 10
	movlw	10
	subwf	DADO1,F
;loop
	goto	SysDoLoop_S3
SysDoLoop_E3
;un = dado1 or 0x30
	movlw	48
	iorwf	DADO1,W
	movwf	UN
	return

;********************************************************************************

Delay_MS
	incf	SysWaitTempMS_H, F
DMS_START
	movlw	142
	movwf	DELAYTEMP2
DMS_OUTER
	movlw	1
	movwf	DELAYTEMP
DMS_INNER
	decfsz	DELAYTEMP, F
	goto	DMS_INNER
	decfsz	DELAYTEMP2, F
	goto	DMS_OUTER
	decfsz	SysWaitTempMS, F
	goto	DMS_START
	decfsz	SysWaitTempMS_H, F
	goto	DMS_START
	return

;********************************************************************************

ENV_BYTE
;set tx_out_ off
	bcf	GPIO,4
;wait 24 us'start bit
	movlw	8
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
;if bser.0 = 1 then
	btfss	BSER,0
	goto	ELSE2_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF2
ELSE2_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF2
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS2
	decfsz	DELAYTEMP,F
	goto	DelayUS2
	nop
;if bser.1 = 1 then
	btfss	BSER,1
	goto	ELSE3_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF3
ELSE3_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF3
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS3
	decfsz	DELAYTEMP,F
	goto	DelayUS3
	nop
;if bser.2 = 1 then
	btfss	BSER,2
	goto	ELSE4_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF4
ELSE4_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF4
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS4
	decfsz	DELAYTEMP,F
	goto	DelayUS4
	nop
;if bser.3 = 1 then
	btfss	BSER,3
	goto	ELSE5_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF5
ELSE5_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF5
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS5
	decfsz	DELAYTEMP,F
	goto	DelayUS5
	nop
;if bser.4 then
	btfss	BSER,4
	goto	ELSE6_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF6
ELSE6_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF6
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS6
	decfsz	DELAYTEMP,F
	goto	DelayUS6
	nop
;if bser.5 = 1 then
	btfss	BSER,5
	goto	ELSE7_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF7
ELSE7_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF7
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS7
	decfsz	DELAYTEMP,F
	goto	DelayUS7
	nop
;if bser.6 = 1 then
	btfss	BSER,6
	goto	ELSE8_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF8
ELSE8_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF8
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS8
	decfsz	DELAYTEMP,F
	goto	DelayUS8
	nop
;if bser.7 = 1 then
	btfss	BSER,7
	goto	ELSE9_1
;set tx_out_ on
	bsf	GPIO,4
;else
	goto	ENDIF9
ELSE9_1
;set tx_out_ off
	bcf	GPIO,4
;NOP
	nop
;end if
ENDIF9
;wait 20 us'
	movlw	6
	movwf	DELAYTEMP
DelayUS9
	decfsz	DELAYTEMP,F
	goto	DelayUS9
	nop
;set tx_out_ on
	bsf	GPIO,4
;wait 26 us'stop bit
	movlw	8
	movwf	DELAYTEMP
DelayUS10
	decfsz	DELAYTEMP,F
	goto	DelayUS10
	nop
	return

;********************************************************************************

ENV_SER
;converte_dec(val1)
	movf	VAL1,W
	movwf	DADO1
	call	CONVERTE_DEC
;aux = "T"
	movlw	84
	movwf	AUX
;env_byte(aux)
	movwf	BSER
	call	ENV_BYTE
;aux = "M"
	movlw	77
	movwf	AUX
;env_byte(aux)
	movwf	BSER
	call	ENV_BYTE
;aux = "R"
	movlw	82
	movwf	AUX
;env_byte(aux)
	movwf	BSER
	call	ENV_BYTE
;aux = "="
	movlw	61
	movwf	AUX
;env_byte(aux)
	movwf	BSER
	call	ENV_BYTE
;aux = " "
	movlw	32
	movwf	AUX
;env_byte(aux)
	movwf	BSER
	call	ENV_BYTE
;env_byte(cent)
	movf	CENT,W
	movwf	BSER
	call	ENV_BYTE
;env_byte(dez)
	movf	DEZ,W
	movwf	BSER
	call	ENV_BYTE
;env_byte(un)
	movf	UN,W
	movwf	BSER
	call	ENV_BYTE
;aux = " "
	movlw	32
	movwf	AUX
;env_byte(aux)
	movwf	BSER
	call	ENV_BYTE
;wait 250 ms
	movlw	250
	movwf	SysWaitTempMS
	clrf	SysWaitTempMS_H
	goto	Delay_MS

;********************************************************************************

INITSYS
;Resolve OSCCAL calibration
;GCB does not load saved calibration data into OSCCAL register on Baseline PIC. Therefore the FOSC is inaccurate when using internal RC oscillator.
;Solution:  Add following as the FIRST lines in the INITSYS sub in the System.h file
;This loads the saved calibration data from the last flash memory location at POR or any time the chip is reset.
;CALL 0x3ff
	call	1023
;movwf osccal
	banksel	OSCCAL
	movwf	OSCCAL
;Set up internal oscillator
;Handle OSCCON1 register for parts that have this register
;Ensure all ports are set for digital I/O and, turn off A/D
;SET ADFM OFF
	banksel	ADCON0
	bcf	ADCON0,ADFM
;Switch off A/D Var(ADCON0)
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;Commence clearing any ANSEL variants in the part
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;End clearing any ANSEL variants in the part
;Turn off comparator - this is the default setting
;CMCON = 7
	movlw	7
	banksel	CMCON
	movwf	CMCON
;Turn off all ports
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysByteTempA, SysByteTempB, SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysByteTempB, W
	movf	SYSBYTETEMPB, W
;subwf SysByteTempA, W
	subwf	SYSBYTETEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************

SysStringTables
	movf	SysStringA_H,W
	movwf	PCLATH
	movf	SysStringA,W
	incf	SysStringA,F
	btfsc	STATUS,Z
	incf	SysStringA_H,F
	movwf	PCL

StringTable1
	retlw	1
	retlw	84	;T


StringTable2
	retlw	1
	retlw	77	;M


StringTable3
	retlw	1
	retlw	82	;R


StringTable4
	retlw	1
	retlw	61	; (equals)


StringTable5
	retlw	1
	retlw	32	; 


;********************************************************************************


 END
